#include<stdio.h>
#include<pthread.h>
#include<stdlib.h>

//change this macro to change the number of threads created
#define MAX_THREADS 32 //20
#define SIZE 16

/* contains individual thread info */
typedef struct ThreadInfo
{
  pthread_t ThreadId;
}ThreadInfo;

static ThreadInfo* g_psThreadInfo = NULL;

int a[SIZE][SIZE];
int b[SIZE][SIZE];
int c[SIZE][SIZE];

void* run(void* args)
{
	int i=0, j=0, k=0;
	//printf("\nThread %d", (long)args);
	
	for(i=0;i<SIZE;i++)
	{
	 for(j=0;j<SIZE;j++)
	 {	
	  c[i][j]=0;
	  for(k=0;k<SIZE;k++)
	  {
		c[i][j] += a[i][k]*b[k][j];
	  }	  
	 }
	}

  	return 0;    
}


int main()
{
 long nCount = 0;
 
 //printf("Start %x\n", pthread_self());
  //allocate memory  for nNumThreads pointers (M pointers for M Threads)
  g_psThreadInfo = (ThreadInfo*)calloc(MAX_THREADS, sizeof(ThreadInfo));
 
  if(!g_psThreadInfo)
        {
                printf("\nMemory Allocation Failed\n");
                return -1;
        }

  for(nCount = 0; nCount < MAX_THREADS; nCount++)
        {
          int nRet = 0;
          nRet = pthread_create(&(g_psThreadInfo[nCount].ThreadId), NULL, run, (void*)nCount);

          if(nRet)
          {
                printf("\nError Creating Thread\n");
                return -2;
          }
        }

  for(nCount = 0; nCount < MAX_THREADS; nCount++)
          {
            int nRet = 0;
            //main thread has to wait till all the newly created threads terminate
            nRet = pthread_join(g_psThreadInfo[nCount].ThreadId, NULL);

            if(nRet)
            {
             printf("\nJoin Operation Failed\n");
            }
          }
            
 //printf("End\n");
 return 1;
}
